/*
 * Copyright (c) 2009 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.fluxml;

import java.io.IOException;
import java.io.Writer;

import org.apache.commons.lang.StringEscapeUtils;

/**
 * HTMLWriter provides a fluent API for HTML serialization
 * 
 * @author tiwe
 * @version $Id$
 */
public class HTMLWriter extends AbstractMarkupWriter<HTMLWriter> {

    public HTMLWriter(Writer writer) {
        super(writer);
    }

    @Override
    protected void escapeMarkup(Writer writer, String val) throws IOException {
        StringEscapeUtils.escapeHtml(writer, val);
    }

    @Override
    protected void closeEmptyTag(Writer writer) throws IOException {
        writer.write(">");
    }

}
